import React, { createContext, useContext, useState } from "react";
import {
  addTodo,
  getTodo,
  getTodoById,
  updateRemainder,
  updateTitle,
  deleteTodo,
} from "../lib/api";
export const TodoContext = createContext();
export const useAppContext = () => useContext(TodoContext);
export function TodoProvider({ children, ...props }) {
  const [task, setTask] = useState([]);

  //POST METHOD
  async function addTask(data) {
    try {
      const taskData = await addTodo(data);
      setTask([...task, taskData]);
    } catch (err) {
      console.log(err.message);
    }
  }
  //PATCH METHOD
  async function updateremainder(id) {
    try {
      console.log("llll", id);
      const response = await updateRemainder(id);

      setTask(response);
    } catch (err) {
      console.log(err.message);
    }
  }
  async function updatetitle(data) {
    try {
      const result = await updateTitle(data);
      setTask([...task, result]);
    } catch (err) {
      console.log(err.message);
    }
  }

  //GET METHOD
  async function getTask() {
    try {
      const taskData = await getTodo();
      setTask(taskData);
    } catch (err) {
      console.log(err.message);
    }
  }

  async function getTaskById(id) {
    try {
      const response = await getTodoById(id);
      setTask(response);
    } catch (err) {
      console.log(err.message);
    }
  }
  //DELETE METHOD
  async function deleteTask(id) {
    try {
      const taskData = await deleteTodo(id);
      setTask(taskData);
    } catch (err) {
      console.log(err.message);
    }
  }

  const value = {
    task,
    addTask,
    updateremainder,
    getTask,
    getTaskById,
    deleteTask,
    updatetitle,
  };
  return (
    <TodoContext.Provider value={value} {...props}>
      {children}
    </TodoContext.Provider>
  );
}
