import { useState } from "react";
import Button from "../../base/button";
import Input from "../../base/input";
import "./form.css";

function Form({ onSubmit }) {
  const [title, setTitle] = useState("");
  let [count, setCount] = useState(0);
  const handleSubmit = (e) => {
    e.preventDefault();
    let len = count + 1;
    setCount(len);
    const data = JSON.parse(
      JSON.stringify({ sId: len, title, isCompleted: false })
    );
    onSubmit(data);
    //setTitle("");
  };

  return (
    <div className="form-section">
      <form onSubmit={handleSubmit}>
        <Input
          required
          value={title}
          onChange={(e) => setTitle(e.target.value)}
        />

        <Button>Submit</Button>
      </form>
    </div>
  );
}

export default Form;
