import { FaTimesCircle } from "react-icons/fa";
import Checkbox from "../../base/checkbox";
import "./task.css";
import { useEffect, useRef, useLayoutEffect, useState } from "react";

function Task({ id, title, isCompleted, onDelete, onChange, onEdit }) {
  const [isedit, setIsEdit] = useState(false);
  const [debouncetitle, setDebounceTitle] = useState(title);
  const textarea_ref = useRef(null);

  const handleDelete = (e) => {
    e.preventDefault();
    const dialog = window.confirm("Do you want to delete?");
    if (dialog) {
      onDelete({ id });
      return true;
    }
    return false;
  };
  const handleChange = () => {
    isCompleted = !isCompleted;
    onChange({ id, isCompleted: isCompleted ? true : false });
  };

  const handleContent = (e) => {
    setIsEdit(true);
    setDebounceTitle(e.target.value);
    const textarea = document.querySelector("textarea");
    textarea.addEventListener("keyup", (e) => {
      let scheight = e.target.scrollHeight;
      textarea.style.height = `${scheight}px`;
    });
  };

  //debounce
  useEffect(() => {
    const handler = setTimeout(() => {
      if (isedit) {
        onEdit({ id, title: debouncetitle });
      }
    }, 3000);

    return () => {
      clearTimeout(handler);
    };
  }, [debouncetitle]);

  useLayoutEffect(() => {
    const scrollHeight = textarea_ref.current.scrollHeight;
    textarea_ref.current.style.height = `${scrollHeight}px`;
  }, [debouncetitle]);
  return (
    <div className="task-section">
      <div>
        <Checkbox
          onChange={handleChange}
          checked={isCompleted}
          disabled={isCompleted}
        />

        <textarea
          ref={textarea_ref}
          className={`${isCompleted ? "strike-through" : ""}`}
          contentEditable={true}
          value={debouncetitle}
          onChange={handleContent}
          disabled={isCompleted}
        ></textarea>
      </div>
      <FaTimesCircle className="fa-close" onClick={handleDelete} />
    </div>
  );
}

export default Task;
