import "./tasks.css";
import Task from "../task";

function Tasks({ tasklist, deleted, remainder, onEdit }) {
  const handleChange = (id) => {
    remainder(id);
  };

  return (
    <div className="tasklist">
      {tasklist.length > 0 &&
        tasklist.map(({ id, title, isCompleted }) => (
          <Task
            key={id}
            id={id}
            title={title}
            isCompleted={isCompleted}
            onEdit={onEdit}
            onChange={() => handleChange(id)}
            onDelete={() => deleted(id)}
          />
        ))}
    </div>
  );
}

export default Tasks;
