const url = "http://192.168.1.91:5000/task";

//POST METHOD
export async function addTodo(data) {
  try {
    const response = await fetch(url, {
      method: "POST",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(data),
    });
    const result = await response.json();
    return result;
  } catch (err) {
    console.log(err.message);
  }
}
//PATCH METHOD
export async function updateRemainder(id) {
  try {
    const response = await getTodoById(id);
    const result = { ...response, isCompleted: !response.isCompleted };

    const updateresponse = await fetch(url + `/${id}`, {
      method: "PUT",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(result),
    });
    const resultData = await getTodo();
    return resultData;
  } catch (err) {
    console.log(err.message);
  }
}
export async function updateTitle(data) {
  try {
    const response = await fetch(url + `/${data.id}`, {
      method: "PATCH",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify({ title: data.title }),
    });
    const resultData = await getTodo();
    return resultData;
  } catch (err) {
    console.log(err.message);
  }
}

//GET METHOD
export async function getTodo() {
  try {
    const response = await fetch(url);
    const result = await response.json();

    return result;
  } catch (err) {
    console.log(err.message);
  }
}

export async function getTodoById(id) {
  try {
    const response = await fetch(url + `/${id}`);
    const result = await response.json();
    return result;
  } catch (err) {
    console.log(err.message);
  }
}
//DELETE METHOD
export async function deleteTodo(id) {
  try {
    await fetch(url + `/${id}`, {
      method: "DELETE",
    });
    const resultData = await getTodo();
    return resultData;
  } catch (err) {
    console.log(err.message);
  }
}
